/*3:*/
#line 109 "../../../source/texk/web2c/mplibdir/mp.w"

typedef struct MP_instance * MP;
/*40:*/
#line 552 "../../../source/texk/web2c/mplibdir/mp.w"

enum mp_filetype
{
	mp_filetype_terminal = 0,
	mp_filetype_error,
	mp_filetype_program,
	mp_filetype_log,
	mp_filetype_postscript,
	mp_filetype_memfile,
	mp_filetype_metrics,
	mp_filetype_fontmap,
	mp_filetype_font,
	mp_filetype_encoding,
	mp_filetype_text
};
typedef char * ( *mp_file_finder ) ( MP, const char *, const char *, int );
typedef void * ( *mp_file_opener ) ( MP, const char *, const char *, int );
typedef char * ( *mp_file_reader ) ( MP, void *, size_t * );
typedef void ( *mp_binfile_reader ) ( MP, void *, void **, size_t * );
typedef void ( *mp_file_closer ) ( MP, void * );
typedef int ( *mp_file_eoftest ) ( MP, void * );
typedef void ( *mp_file_flush ) ( MP, void * );
typedef void ( *mp_file_writer ) ( MP, void *, const char * );
typedef void ( *mp_binfile_writer ) ( MP, void *, void *, size_t );

/*:40*//*134:*/
#line 1990 "../../../source/texk/web2c/mplibdir/mp.w"

enum mp_interaction_mode
{
	mp_unspecified_mode = 0,
	mp_batch_mode,
	mp_nonstop_mode,
	mp_scroll_mode,
	mp_error_stop_mode
};

/*:134*//*140:*/
#line 2071 "../../../source/texk/web2c/mplibdir/mp.w"

enum mp_history_state
{
	mp_spotless = 0,
	mp_warning_issued,
	mp_error_message_issued,
	mp_fatal_error_stop,
	mp_system_error_stop
};

/*:140*//*152:*/
#line 2221 "../../../source/texk/web2c/mplibdir/mp.w"

typedef void ( *mp_editor_cmd ) ( MP, char *, int );

/*:152*//*384:*/
#line 7162 "../../../source/texk/web2c/mplibdir/mp.w"

enum mp_knot_originator
{
	mp_program_code = 0,
	mp_metapost_user
};

/*:384*//*967:*/
#line 16836 "../../../source/texk/web2c/mplibdir/mp.w"

typedef int ( *mp_makempx_cmd ) ( MP mp, char * origname, char * mtxname );

/*:967*//*1255:*/
#line 22521 "../../../source/texk/web2c/mplibdir/mp.w"

typedef struct
{
	void * fptr;
	char * data;
	char * cur;
	size_t size;
	size_t used;
} mp_stream;

typedef struct
{
	mp_stream term_out;
	mp_stream error_out;
	mp_stream log_out;
	mp_stream ps_out;
	mp_stream term_in;
	struct mp_edge_object * edges;
} mp_run_data;

/*:1255*//*1500:*/
#line 26527 "../../../source/texk/web2c/mplibdir/mp.w"

typedef void ( *mp_backend_writer ) ( MP, int );

/*:1500*/
#line 111 "../../../source/texk/web2c/mplibdir/mp.w"

typedef struct MP_options
{
	/*23:*/
#line 372 "../../../source/texk/web2c/mplibdir/mp.w"
	
	int error_line;
	int half_error_line;
	
	int halt_on_error;
	int max_print_line;
	unsigned hash_size;
	
	int param_size;
	int max_in_open;
	
	int main_memory;
	void * userdata;
	char * banner;
	
	/*:23*//*41:*/
#line 576 "../../../source/texk/web2c/mplibdir/mp.w"
	
	mp_file_finder find_file;
	mp_file_opener open_file;
	mp_file_reader read_ascii_file;
	mp_binfile_reader read_binary_file;
	mp_file_closer close_file;
	mp_file_eoftest eof_file;
	mp_file_flush flush_file;
	mp_file_writer write_ascii_file;
	mp_binfile_writer write_binary_file;
	
	/*:41*//*46:*/
#line 646 "../../../source/texk/web2c/mplibdir/mp.w"
	
	int print_found_names;
	
	/*:46*//*48:*/
#line 664 "../../../source/texk/web2c/mplibdir/mp.w"
	
	int file_line_error_style;
	
	/*:48*//*65:*/
#line 919 "../../../source/texk/web2c/mplibdir/mp.w"
	
	char * command_line;
	
	/*:65*//*135:*/
#line 1999 "../../../source/texk/web2c/mplibdir/mp.w"
	
	int interaction;
	int noninteractive;
	
	/*:135*//*153:*/
#line 2224 "../../../source/texk/web2c/mplibdir/mp.w"
	
	mp_editor_cmd run_editor;
	
	/*:153*//*234:*/
#line 3673 "../../../source/texk/web2c/mplibdir/mp.w"
	
	int random_seed;
	
	/*:234*//*300:*/
#line 5228 "../../../source/texk/web2c/mplibdir/mp.w"
	
	int troff_mode;
	
	/*:300*//*934:*/
#line 16338 "../../../source/texk/web2c/mplibdir/mp.w"
	
	char * mem_name;
	
	/*:934*//*947:*/
#line 16509 "../../../source/texk/web2c/mplibdir/mp.w"
	
	char * job_name;
	
	/*:947*//*968:*/
#line 16839 "../../../source/texk/web2c/mplibdir/mp.w"
	
	mp_makempx_cmd run_make_mpx;
	
	/*:968*//*1501:*/
#line 26530 "../../../source/texk/web2c/mplibdir/mp.w"
	
	mp_backend_writer shipout_backend;
	
	/*:1501*//*1513:*/
#line 26615 "../../../source/texk/web2c/mplibdir/mp.w"
	
	int ini_version;
	
	/*:1513*/
#line 113 "../../../source/texk/web2c/mplibdir/mp.w"
	
} MP_options;
/*14:*/
#line 303 "../../../source/texk/web2c/mplibdir/mp.w"

extern MP_options * mp_options ( void );
extern MP mp_initialize ( MP_options * opt );
extern int mp_status ( MP mp );
extern void * mp_userdata ( MP mp );

/*:14*//*150:*/
#line 2197 "../../../source/texk/web2c/mplibdir/mp.w"

extern void mp_error ( MP mp );
extern void mp_warn ( MP mp, const char * msg );


/*:150*//*167:*/
#line 2421 "../../../source/texk/web2c/mplibdir/mp.w"

extern void mp_fatal_error ( MP mp, const char * s );


/*:167*//*302:*/
#line 5249 "../../../source/texk/web2c/mplibdir/mp.w"

int mp_troff_mode ( MP mp );

/*:302*//*1254:*/
#line 22502 "../../../source/texk/web2c/mplibdir/mp.w"

void mp_set_internal ( MP mp, char * n, char * v, int isstring );

/*:1254*//*1263:*/
#line 22837 "../../../source/texk/web2c/mplibdir/mp.w"

extern mp_run_data * mp_rundata ( MP mp );

/*:1263*//*1271:*/
#line 22974 "../../../source/texk/web2c/mplibdir/mp.w"

int mp_run ( MP mp );
int mp_execute ( MP mp, const char * s, size_t l );
int mp_finish ( MP mp );
char * mp_metapost_version ( void );

/*:1271*//*1458:*/
#line 25761 "../../../source/texk/web2c/mplibdir/mp.w"

double mp_get_char_dimension ( MP mp, const char * fname, int n, int t );


/*:1458*//*1525:*/
#line 26823 "../../../source/texk/web2c/mplibdir/mp.w"

int mp_memory_usage ( MP mp );
int mp_hash_usage ( MP mp );
int mp_param_usage ( MP mp );
int mp_open_usage ( MP mp );

/*:1525*/
#line 115 "../../../source/texk/web2c/mplibdir/mp.w"


/*:3*//*306:*/
#line 5361 "../../../source/texk/web2c/mplibdir/mp.w"

enum mp_color_model
{
	mp_no_model = 1,
	mp_grey_model = 3,
	mp_rgb_model = 5,
	mp_cmyk_model = 7,
	mp_uninitialized_model = 9
};


/*:306*//*382:*/
#line 7075 "../../../source/texk/web2c/mplibdir/mp.w"

enum mp_knot_type
{
	mp_endpoint = 0,
	mp_explicit,
	mp_given,
	mp_curl,
	mp_open,
	mp_end_cycle
};

/*:382*//*519:*/
#line 9362 "../../../source/texk/web2c/mplibdir/mp.w"

enum mp_graphical_object_code
{
	/*521:*/
#line 9405 "../../../source/texk/web2c/mplibdir/mp.w"
	
	mp_fill_code = 1,
	
	/*:521*//*525:*/
#line 9450 "../../../source/texk/web2c/mplibdir/mp.w"
	
	mp_stroked_code = 2,
	
	/*:525*//*532:*/
#line 9542 "../../../source/texk/web2c/mplibdir/mp.w"
	
	mp_text_code = 3,
	
	/*:532*//*535:*/
#line 9595 "../../../source/texk/web2c/mplibdir/mp.w"
	
	mp_start_clip_code = 4,
	mp_start_bounds_code = 5,
	mp_stop_clip_code = 6,
	mp_stop_bounds_code = 7,
	
	/*:535*//*1491:*/
#line 26263 "../../../source/texk/web2c/mplibdir/mp.w"
	
	mp_special_code = 8,
	
	/*:1491*/
#line 9364 "../../../source/texk/web2c/mplibdir/mp.w"
	
	mp_final_graphic
};

/*:519*/
