/*171:*/
#line 4914 "../../../source/texk/web2c/mplibdir/psout.w"

typedef struct mp_knot
{
	unsigned short left_type;
	unsigned short right_type;
	signed int x_coord;
	signed int y_coord;
	signed int left_x;
	signed int left_y;
	signed int right_x;
	signed int right_y;
	struct mp_knot * next;
	unsigned char originator;
} mp_knot;

/*:171*//*181:*/
#line 5092 "../../../source/texk/web2c/mplibdir/psout.w"

typedef struct
{
	int a_val, b_val, c_val, d_val;
} mp_color;

/*:181*//*182:*/
#line 5102 "../../../source/texk/web2c/mplibdir/psout.w"

typedef struct
{
	int offset;
	int * array;
} mp_dash_object;


/*:182*//*187:*/
#line 5184 "../../../source/texk/web2c/mplibdir/psout.w"

#define GRAPHIC_BODY                      \
  int type;                               \
  struct mp_graphic_object * next

typedef struct mp_graphic_object
{
	GRAPHIC_BODY;
} mp_graphic_object;

typedef struct mp_text_object
{
	GRAPHIC_BODY;
	char * pre_script;
	char * post_script;
	mp_color color;
	unsigned char color_model;
	unsigned char size_index;
	char * text_p;
	size_t text_l;
	char * font_name;
	unsigned int font_dsize;
	unsigned int font_n;
	int width;
	int height;
	int depth;
	int tx;
	int ty;
	int txx;
	int txy;
	int tyx;
	int tyy;
} mp_text_object;

typedef struct mp_fill_object
{
	GRAPHIC_BODY;
	char * pre_script;
	char * post_script;
	mp_color color;
	unsigned char color_model;
	unsigned char ljoin;
	mp_knot * path_p;
	mp_knot * htap_p;
	mp_knot * pen_p;
	int miterlim;
} mp_fill_object;

typedef struct mp_stroked_object
{
	GRAPHIC_BODY;
	char * pre_script;
	char * post_script;
	mp_color color;
	unsigned char color_model;
	unsigned char ljoin;
	unsigned char lcap;
	mp_knot * path_p;
	mp_knot * pen_p;
	int miterlim;
	mp_dash_object * dash_p;
} mp_stroked_object;

typedef struct mp_clip_object
{
	GRAPHIC_BODY;
	mp_knot * path_p;
} mp_clip_object;

typedef struct mp_bounds_object
{
	GRAPHIC_BODY;
	mp_knot * path_p;
} mp_bounds_object;

typedef struct mp_special_object
{
	GRAPHIC_BODY;
	char * pre_script;
} mp_special_object;

typedef struct mp_edge_object
{
	struct mp_graphic_object * body;
	struct mp_edge_object * next;
	char * filename;
	MP parent;
	int minx, miny, maxx, maxy;
	int width, height, depth, ital_corr;
	int charcode;
} mp_edge_object;

/*:187*//*236:*/
#line 6196 "../../../source/texk/web2c/mplibdir/psout.w"

int mp_ps_ship_out ( mp_edge_object * hh, int prologues, int procset );

/*:236*//*241:*/
#line 6251 "../../../source/texk/web2c/mplibdir/psout.w"

void mp_gr_toss_objects ( mp_edge_object * hh );
void mp_gr_toss_object ( mp_graphic_object * p );

/*:241*//*244:*/
#line 6315 "../../../source/texk/web2c/mplibdir/psout.w"

mp_graphic_object * mp_gr_copy_object ( MP mp, mp_graphic_object * p );

/*:244*/
